#
#         Simulation of
#       Two Moving Bodies
#
import numpy as np
import pygame as pg
import sys

pg.init()
screen = pg.display.set_mode(size=(800,700))
screen.fill((0, 0, 0))
pg.display.flip()

def x_scale(x):
    return 400 + x * 100

def y_scale(y):
    return 350 + y * 100
#
#       The initial values
#
x0 = 3.0
y0 = 0.0
x1 = 0.0
y1 = 0.0
vx0h = 0.0
vy0h = -0.8
vx1h = 0.0
vy1h = 0.1

d_t = 0.001

while True:
    #
    #     Calculation of values for update
    #
    x0_t = x0 + d_t * vx0h
    y0_t = y0 + d_t * vy0h
    x1_t = x1 + d_t * vx1h
    y1_t = y1 + d_t * vy1h
    r3 = ((x0_t - x1_t)**2 + (y0_t - y1_t)**2) ** (3/2)
    vx0h_t = vx0h + d_t * (-8) * (x0_t - x1_t) / r3
    vy0h_t = vy0h + d_t * (-8) * (y0_t - y1_t) / r3
    vx1h_t = vx1h + d_t * (x0_t - x1_t) / r3
    vy1h_t = vy1h + d_t * (y0_t - y1_t) / r3
    #
    #        Update the values
    #    cf. Feynman et al. (1963), p. 9-6.
    #
    x0 = x0_t
    y0 = y0_t
    x1 = x1_t
    y1 = y1_t
    vx0h = vx0h_t
    vy0h = vy0h_t
    vx1h = vx1h_t
    vy1h = vy1h_t
    #
    #        Display the updated values
    #        
    screen.fill((0, 0, 0))
    pg.draw.circle(screen, (255, 200,255), (x_scale(x0), y_scale(y0)), 5)
    pg.draw.circle(screen, (0, 255, 255), (x_scale(x1), y_scale(y1)), 20)
    pg.display.flip()

    for e in pg.event.get():
        if e.type == pg.QUIT:    #   Is the windows's close button clicked?
            pg.quit()
            sys.exit()

    pg.time.wait(1)

